/*
 * 
 * Vericon version 4.3. Generated Tue Sep 12 10:47:57 2017
 * Auto generated testbench, post edited 
 *
 */

module axi_dpm32_test;

localparam CLK_PERIOD=100;

localparam ADRS_BITS= 32;
localparam DATA_BITS= 32;
localparam LEN_BITS = 4;
localparam ID_BITS  = 6;
                         // Depth of the queues (FIFOs)
localparam AQ_DEPTH = 10; // Max 1K addresses
localparam DQ_DEPTH = 16; // Max 64K data 
                           // 2-Log depth of the memory in data bits above 
localparam L2MEM_DEPTH= 6;


reg                  clk;
reg                  reset_n;
reg                  run_master;
   
   //
   // AXI port 
   //
   
   // write address 
   
wire                 awvalid;
wire                 awready;
wire [ADRS_BITS-1:0] awaddr;
wire [LEN_BITS-1:0] awlen;
wire         [  2:0] awsize;
wire [ID_BITS-1:0] awid;
wire         [  1:0] awburst;
                           
   // write data           
wire                 wvalid;
wire                 wready;
wire [DATA_BITS-1:0] wdata;
wire         [  3:0] wstrb;
wire                 wlast;
wire [ID_BITS-1:0] wid;

   // write response    
wire                 bvalid;
wire                 bready;
wire         [  1:0] bresp;
wire         [  1:0] rresp;
wire [ID_BITS-1:0] bid;


   //
   // read interface
   //
   
   // read address 
wire                 arvalid;
wire                 arready;
wire [ADRS_BITS-1:0] araddr;
wire [ID_BITS-1:0] arid;
wire         [  3:0] arlen;
wire         [  2:0] arsize;
wire         [  1:0] arburst;

   // read data
wire                 rvalid;
wire                 rready;
wire [DATA_BITS-1:0] rdata;
wire                 rlast;
wire [ID_BITS-1:0] rid;

   initial
   begin

      clk      = 1'b0;
      reset_n  = 1'b0;
      run_master = 1'b0;
   
  //
   // read interface
   //
   
   // read address 
      arvalid  = 1'b0;
      araddr   = 'b0;
      arid     = 'b0;
      arlen    = 4'b0;
      arsize   = 3'b0;
      arburst  = 2'b0;
      rready   = 1'b0;
      
      #(CLK_PERIOD * 5) ;
      reset_n = 1'b1;
      #(CLK_PERIOD * 5) ;
      

         // Address and data both after 4 cycles
      axi_test_master.q_wsync(
                     32'h00000000, // address;
                                1, // length;
                               32, // size;
                                2, // id;
                                1, // burst;
                                0, // delay_random;
                                4, // delay;
                     32'h11223344, // data;
                             4'hF, // strobes;
                                1, // last;
                                0, // delay_random;
                                4  // delay;
                               );
      
      // Address and data both after 2 cycles
      // Burst of 2 
      axi_test_master.q_wsync(
                     32'h00000020, // address;
                                  2, // length;
                               32, // size;
                                3, // id;
                                1, // burst;
                                0, // delay_random;
                                2, // delay;
                     32'hAA2233xx, // data;
                             4'hE, // strobes;
                                  0, // last;
                                0, // delay_random;
                                2  // delay;
                               );
      axi_test_master.q_wdata(32'hxxxxxx88, 4'h1,1,3,0,1);
      //                                   LAST  ^ !! 
      // Address and data both after 0 cycles
      // Burst of 2 
      axi_test_master.q_wsync(
                     32'h00000020, // address;
                                  2, // length;
                               32, // size;
                                3, // id;
                                1, // burst;
                                0, // delay_random;
                                0, // delay;
                     32'hxxxxxx44, // data;
                             4'h1, // strobes;
                                  0, // last;
                                0, // delay_random;
                                0  // delay;
                               );
      axi_test_master.q_wdata(32'h556677xx, 4'hE,1,3,0,1);
      //                                   LAST  ^ !! 
      
      
      run_master = 1'b1;
      #(CLK_PERIOD * 50) ;
      run_master = 1'b0;
      if (axi_dpm32_0.read(32'h00000000)!==32'h11223344)
      begin
         $display("%m @%0t: Mem adrs 0 read verify error",$time);
         $stop;
      end
      if (axi_dpm32_0.read(32'h00000020)!==32'hAA223344)
      begin
         $display("%m @%0t: Mem adrs 0x20 (8)  read verify error",$time);
         $stop;
      end
      if (axi_dpm32_0.read(32'h00000024)!==32'h55667788)
      begin
         $display("%m @%0t: Mem adrs 0x24 (9) read verify error",$time);
         $stop;
      end
      
      

      #(CLK_PERIOD * 50) ;
      $stop;

    end

   
axi_test_master

   #(
      .ADRS_BITS (ADRS_BITS),
      .DATA_BITS (DATA_BITS),
      .LEN_BITS  (LEN_BITS) ,
      .ID_BITS   (ID_BITS)  ,
                                 // Depth of the queues (FIFOs)
      .AQ_DEPTH  (AQ_DEPTH) ,  // Max 1K addresses
      .DQ_DEPTH  (DQ_DEPTH)    // Max 64K data 

   ) // parameters
axi_test_master_0 (

      .clk    (clk),
      .reset_n(reset_n),
      .run    (run_master),

      .awvalid(awvalid),
      .awready(awready),
      .awaddr (awaddr),
      .awlen  (awlen),
      .awsize (awsize),
      .awid   (awid),
      .awburst(awburst),
   
      .awcache(),
      .awlock (),
      .awprot (),
      .awqos  (),
                           
   // write data           
      .wvalid (wvalid),
      .wready (wready),
      .wdata  (wdata),
      .wstrb  (wstrb),
      .wlast  (wlast),
      .wid    (wid),

   // write response    
      .bvalid (bvalid),
      .bready (bready),
      .bresp  (bresp),
      .rresp  (rresp),
      .bid    (bid),
      
   // read address
      .arvalid(arvalid),
      .arready(arready),
      .araddr (araddr),
      .arlen  (arlen),
      .arsize (arsize),
      .arid   (arid),
      .arburst(arburst),
   
      .arcache(arcache),
      .arlock (arlock),
      .arprot (arprot),
      .arqos  (arqos),
      
   // read data
      .rvalid (rvalid),
      .rready (rready),
      .rdata  (rdata),
      .rlast  (rlast),
      .rid    (rid) 
      
   );



axi_dpm32
   #(
      .ADRS_BITS   (ADRS_BITS)  ,
      .DATA_BITS   (DATA_BITS)  ,
      .LEN_BITS    (LEN_BITS)   ,
      .ID_BITS     (ID_BITS)    ,
                                     // 2-Log depth of the memory in data bits above 
      .L2MEM_DEPTH (L2MEM_DEPTH)
   ) // parameters
axi_dpm32_0 (

      .clk    (clk),
      .reset_n(reset_n),
   
   //
   // AXI port 
   //
   
   // write address 
   
      .awvalid(awvalid),
      .awready(awready),
      .awaddr (awaddr),
      .awlen  (awlen),
      .awsize (awsize),
      .awid   (awid),
      .awburst(awburst),
                           
   // write data           
      .wvalid (wvalid),
      .wready (wready),
      .wdata  (wdata),
      .wstrb  (wstrb),
      .wlast  (wlast),
      .wid    (wid),

   // write response    
      .bvalid (bvalid),
      .bready (bready),
      .bresp  (bresp),
      .rresp  (rresp),
      .bid    (bid),


   //
   // read interface
   //
   
   // read address 
      .arvalid(arvalid),
      .arready(arready),
      .araddr (araddr),
      .arid   (arid),
      .arlen  (arlen),
      .arsize (arsize),
      .arburst(arburst),

   // read data
      .rvalid (rvalid),
      .rready (rready),
      .rdata  (rdata),
      .rlast  (rlast),
      .rid    (rid) 
   );



   // General clock & reset section
   always @(posedge clk or negedge reset_n)
   begin
      if (!reset_n)
      begin
      end
      else
      begin
      end
   end

   // Generate clock.
   initial
   begin
      clk = 1'b0;
      forever
         #(CLK_PERIOD/2) clk = ~clk;
   end

endmodule
